/*******************************************************************************
 Copyright (c) 2015, Infineon Technologies AG                                 **
 All rights reserved.                                                         **
                                                                              **
 Redistribution and use in source and binary forms, with or without           **
 modification,are permitted provided that the following conditions are met:   **
                                                                              **
 *Redistributions of source code must retain the above copyright notice,      **
 this list of conditions and the following disclaimer.                        **
 *Redistributions in binary form must reproduce the above copyright notice,   **
 this list of conditions and the following disclaimer in the documentation    **
 and/or other materials provided with the distribution.                       **
 *Neither the name of the copyright holders nor the names of its contributors **
 may be used to endorse or promote products derived from this software without**
 specific prior written permission.                                           **
                                                                              **
 THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"  **
 AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE    **
 IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE   **
 ARE  DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE   **
 LIABLE  FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR         **
 CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF         **
 SUBSTITUTE GOODS OR  SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS    **
 INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN      **
 CONTRACT, STRICT LIABILITY,OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)       **
 ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE   **
 POSSIBILITY OF SUCH DAMAGE.                                                  **
                                                                              **
 To improve the quality of the software, users are encouraged to share        **
 modifications, enhancements or bug fixes with Infineon Technologies AG       **
 dave@infineon.com).                                                          **
                                                                              **
********************************************************************************
**                                                                            **
**                                                                            **
** PLATFORM : Infineon XMC4500 Series                                         **
**                                                                            **
** AUTHOR : Application Engineering Team                                      **
**                                                                            **
** version 4.0.0  Initial version                                             **
**         4.1.2  Modified for APP updates                                    **
**         4.1.4  Modified for APP updates                                    **
**                                                                            **
** MODIFICATION DATE : October, 30, 2015                                      **
**                                                                            **
*******************************************************************************/




#include <DAVE.h>                 //Declarations from DAVE Code Generation (includes SFR declaration)

/*******************************************************************************
 ** EXTERN Declarations                                                       **
 ******************************************************************************/
extern const GUI_BITMAP bmIFX_LOGO;
extern const GUI_BITMAP bmXMC_test;

void delay (unsigned int count);

/**
 * @brief main() - Application entry point
 *
 * <b>Details of function</b><br>
 * This routine is the application entry point. It is invoked by the device startup code. It is responsible for
 * invoking the App initialization dispatcher routine - DAVE_Init() and hosting the place-holder for user application
 * code.
 */
int main(void)
{
  DAVE_STATUS_t status;

  status = DAVE_Init();           /* Initialization of DAVE APPs  */

  if(status == DAVE_STATUS_FAILURE)
  {
    /* Placeholder for error handler code. The while loop below can be replaced with an user error handler. */
    XMC_DEBUG("DAVE APPs initialization failed\n");

    while(1U)
    {

    }
  }
  /* Set background colour */
      GUI_SetBkColor(GUI_WHITE);
      /* Clear screen */
      GUI_Clear();

  /* Placeholder for user application code. The while loop below can be replaced with user application code. */
  while(1U)
  {

	  /* Display IFX image */
	  	  		GUI_DrawBitmap(&bmIFX_LOGO, 5, 32);
	  	  		delay(36000000);
	  	  		GUI_Clear();

	  	  		/* Display text */
	  	  		GUI_SetFont(&GUI_Font24B_1);
	  	  		GUI_SetColor(GUI_BLUE);
	  	  		GUI_DispStringHCenterAt("proudly", 80, 30);
	  	  		GUI_DispStringHCenterAt("presents...", 80, 60);
	  	  		delay(24000000);
	  	  		GUI_Clear();

	  	  		/* Display XMC image */
	  	  		GUI_DrawBitmap(&bmXMC_test, 0, 0);
	  	  		delay(48000000);
	  	  		GUI_Clear();
  }
}
/**
 * @brief Delay function:This routine is used for creating delay
 * @param[in] count (value = n sec X 12 X 1000000)
 * @return None
 */
void delay (volatile unsigned int count)
{
	while (count != 0)
	{
		count--;
	}
}

